---
title: handler.apply()
slug: Web/JavaScript/Reference/Global_Objects/Proxy/Proxy/apply
tags:
  - ECMAScript 2015
  - JavaScript
  - Method
  - Proxy
---
<div>{{JSRef}}</div>

<p>The <strong><code>handler.apply()</code></strong> method is a trap for a function call.</p>

<div>{{EmbedInteractiveExample("pages/js/proxyhandler-apply.html", "taller")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">const <var>p</var> = new Proxy(<var>target</var>, {
  apply: function(<var>target</var>, <var>thisArg</var>, <var>argumentsList</var>) {
  }
});
</pre>

<h3 id="Parameters">Parameters</h3>

<p>The following parameters are passed to the <code>apply()</code> method. <code>this</code> is bound to the handler.</p>

<dl>
 <dt><code><var>target</var></code></dt>
 <dd>The target object.</dd>
 <dt><code><var>thisArg</var></code></dt>
 <dd>The <code>this</code> argument for the call.</dd>
 <dt><code><var>argumentsList</var></code></dt>
 <dd>The list of arguments for the call.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The <code>apply()</code> method can return any value.</p>

<h2 id="Description">Description</h2>

<p>The <code><strong>handler.apply()</strong></code> method is a trap for a function call.</p>

<h3 id="Interceptions">Interceptions</h3>

<p>This trap can intercept these operations:</p>

<ul>
 <li><code><var>proxy</var>(...<var>args</var>)</code></li>
 <li>{{jsxref("Function.prototype.apply()")}} and {{jsxref("Function.prototype.call()")}}</li>
 <li>{{jsxref("Reflect.apply()")}}</li>
</ul>

<h3 id="Invariants">Invariants</h3>

<p>If the following invariants are violated, the proxy will throw a {{jsxref("TypeError")}}.</p>

<p>The <code><var>target</var></code> must be a callable itself. That is, it must be a function object.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Trapping_a_function_call">Trapping a function call</h3>

<p>The following code traps a function call.</p>

<pre class="brush: js notranslate">const p = new Proxy(function() {}, {
  apply: function(target, thisArg, argumentsList) {
    console.log('called: ' + argumentsList.join(', '));
    return argumentsList[0] + argumentsList[1] + argumentsList[2];
  }
});

console.log(p(1, 2, 3)); // "called: 1, 2, 3"
                         // 6
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-proxy-object-internal-methods-and-internal-slots-call-thisargument-argumentslist', '[[Call]]')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Proxy.handler.apply")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Proxy")}}</li>
 <li>{{jsxref("Proxy.handler", "handler")}}</li>
 <li>{{jsxref("Function.prototype.apply()")}}</li>
 <li>{{jsxref("Function.prototype.call()")}}</li>
 <li>{{jsxref("Reflect.apply()")}}</li>
</ul>
